package venice;

import java.io.*;
import javax.swing.*;

/**
 * Exports data from model storage to a GXL file.
 *
 * @author Hannu Laurila
 */
public class ExportGXLFileCommand extends Command
{
    /**
     * asks user for file location, opens outputstream and saves
     * GXL to output stream.
     */
    public void execute()
    {
        JFileChooser myFC = new JFileChooser();
	GXLFileFilter myFF = new GXLFileFilter();
        myFC.addChoosableFileFilter(myFF);
        
        int returnVal = myFC.showSaveDialog(null);

        if(returnVal != JFileChooser.APPROVE_OPTION)
            return;

        try {
            File mySaveFile = myFC.getSelectedFile();

            if (mySaveFile.getName().indexOf('.') == (-1) &&
                myFC.getFileFilter() == myFF) {
                String myCanonicalFN =
                    mySaveFile.getCanonicalPath() +
		    myFF.getJoinableExtension();
                mySaveFile = new File(myCanonicalFN);
            }

            OutputStream myOs = new FileOutputStream(mySaveFile);
	    getAppModule().getModelStorage().writeGXL(myOs);
        }
        catch (IOException ex) {
            Util.handleException(ex);
        }
    }
}
