/**
 * @(#) HideVRelationshipLabelsCommand.java
 */

package venice;


/**
 * Command subclass, which sets all labels for all relationships as invisible.
 * 
 * @author	Petteri Kamppuri
 * @version	1.0
 * 
 */
public class HideVRelationshipLabelsCommand extends Command
{
    /**
     * 
     * 
     */
    public void execute()
    {
	mVisualization	= getAppModule().getGui().getVisualization();
	
	setChildrensRelationshipsAsInvisible(mVisualization.getRootPackage());
    }
    
    private void setChildrensRelationshipsAsInvisible(VPackage inPackage)
    {
	VModelElement[] myChildren = inPackage.getVChildren();
	
	for(int i = 0; i < myChildren.length; ++i) {
	    if(myChildren[i] instanceof VRelationship) {
		((VRelationship) myChildren[i]).setLabelVisible(false);
	    } else if(myChildren[i] instanceof VPackage) {
		setChildrensRelationshipsAsInvisible((VPackage) myChildren[i]);
	    }
	}
    }    
    
    /**
     * Private variable to hold the Visualization instance that is needed
     * in various places in the recursive action of this object. 
     */
    private Visualization mVisualization	= null;   
}
