package venice;

import java.util.LinkedList;
import java.util.ListIterator;

/**
 * This class is a representation for model elements in the model.
 *
 * @author Sami Ilonen
 */

public class MInterface extends MElement {

	private LinkedList mOperations; 

	/**
	 * Returns the operations of this interface.
	 *
	 */

	public MInterface (String inId, String inName, String inType, LinkedList inOps) {
		super(inId,inName,inType);
		mOperations = inOps;
	}

	public LinkedList getOperations() {
		return mOperations;
	}

	public String toXML() {
		String outString;
		outString = "<node id=\"" + this.getId() + "\">\n";

		outString += "<type xlink:href=\"schema.gxl#Interface\"/>\n";

		outString += "<attr name=\"Name\">\n";
		outString += "<string>"+this.getName()+"</string>\n";
		outString += "</attr>\n";
		
		outString += "<attr name=\"Type\">\n";
		outString += "<string>"+this.getType()+"</string>\n";
		outString += "</attr>\n";
		
		ListIterator it = this.mOperations.listIterator();
		String myTemp;
		while (it.hasNext()) {
			myTemp = (String) it.next();
			outString += "<attr name=\"Operation\">\n";
			outString += "<string>"+myTemp+"</string>\n";
			outString += "</attr>\n";
		}
		outString += "</node>\n";
		return outString;
	}
}
